//////////////////////////////////////////////////////////////////////////////////////
//																																									//
//	Ce jeu fonctionne sur les TI-89/92/92+/V200: il s'adapte automatiquement 			//
//	chaque machine.																																	//
//																																									//
//////////////////////////////////////////////////////////////////////////////////////

//	Adaptations pour fonctionner sur TI-89/92+/V200	//

#define ADAPT_x     (LCD_WIDTH-160)/2     // Adapte la largeur TI-89/TI-92
#define ADAPT_y     (LCD_HEIGHT-100)/2    // Adapte la hauteur TI-89/TI-92
#define NUM_COL     TI89? 7: 10           // Adapte le nombre de colonnes dans
    																			// la matrice clavier	
#define QUICK_EXIT	(TI89? 5: 1), (TI89? 6: 4) // [HOME] pour TI-89  																			
																							 // [F8] pour	TI-92+																			
//////////////////////////////////////////////////////////////////////////////////////

// Taille de la police //

#define PETIT				0
#define NORMAL			1
#define GROS				2

//////////////////////////////////////////////////////////////////////////////////////


// Niveaux de gris //

#define GRIS_CLAIR	0
#define GRIS_FONCE  1

//////////////////////////////////////////////////////////////////////////////////////

// Structure des Highscores    
    
typedef struct
  {
    unsigned char nom[12]; // 13 bytes
    unsigned short score; // 2 bytes
  } HIGH_SCORES;
  
static HIGH_SCORES high[5]={
{"-Thanks to-", 500},
{"<<Z.Juric>>", 400},
{"**R.Wagner*", 300},
{"**F.Leiber*", 200},
{"**F.Racine*", 100},
}; // 15x5 = 75 bytes

unsigned char * Sauvegarde = NULL; // Variable de sauvegarde pour une 'QUICK_EXIT_SAVE'
SYM_ENTRY * entry = NULL;
unsigned char * Hsc = NULL; // Variable de sauvegarde pour les hiscores

/*************************************************************************************/
                                     
INT_HANDLER int1 = NULL, int5 = NULL;
unsigned char * plan0 = NULL, * plan1 = NULL; // Adresse des niveaux de gris: plan0 = LIGHT_PLANE; plan1 = DARK_PLANE.
SCR_RECT ecran = {{0, 0, 239, 127}} ;
short DROITE = 0, GAUCHE = 0, BAS = 0, HAUT = 0, ENTER = 0, ESCAPE = 0, vitesse = 1, ordre = 0, x_pom = 0, y_pom = 0,
x_bonus = 0, y_bonus = 0, QUICK_EXIT_NO_SAVE = 0, QUICK_EXIT_SAVE = 0;

//////////////////////////////////////////////////////////////////////////////////////
//																																									//
//	Redirige les interruptions 1, 4 et 5 vers 'rien' (i.e. DUMMY_HANDLER) au     		//
//	dbut du programme puis les restaure  la fin.																	//
//																																									//
//////////////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////////////

void redirige_int(void)
{
	QUICK_EXIT_SAVE = 0;
	QUICK_EXIT_NO_SAVE = 0;
	randomize();
	int1 = GetIntVec(AUTO_INT_1);
	int5 = GetIntVec(AUTO_INT_5);
	SetIntVec(AUTO_INT_1, DUMMY_HANDLER);
	SetIntVec(AUTO_INT_5, DUMMY_HANDLER);
	if(!GrayOn())
	 return;
	plan0 = GetPlane(0);
	plan1 = GetPlane(1);
}

//////////////////////////////////////////////////////////////////////////////////////

void restaure_int(void)
{
	GrayOff();
	SetIntVec(AUTO_INT_1, int1);
	SetIntVec(AUTO_INT_5, int5);
	OSTimerRestart(APD_TIMER);
}

//////////////////////////////////////////////////////////////////////////////////////